﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="BookRecords.aspx.vb" Inherits="BookRecords" %>
<%--Elliot Slack--%>
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Book Records</title>
    <link href="MyStyles.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <h2>Book Records</h2>
    <h3>Elliot Slack</h3>
    <form id="form1" runat="server">
         <asp:DropDownList ID="ddlPublishers" runat="server" AutoPostBack="True" DataSourceID="ds_ddl_Publisher" DataTextField="Name" DataValueField="PubID">
        </asp:DropDownList>

        <asp:SqlDataSource ID="DS_grdBooks" runat="server" ConnectionString="<%$ ConnectionStrings:connStrBooksDB %>" DeleteCommand="DELETE FROM [Books] WHERE [ISBN] = @ISBN" InsertCommand="INSERT INTO [Books] ([ISBN], [Title], [PubDate], [PubID], [Cost], [Retail], [Category]) VALUES (@ISBN, @Title, @PubDate, @PubID, @Cost, @Retail, @Category)" SelectCommand="SELECT * FROM [Books] WHERE ([PubID] = @PubID)
ORDER BY Title" UpdateCommand="UPDATE [Books] SET [Title] = @Title, [PubDate] = @PubDate, [PubID] = @PubID, [Cost] = @Cost, [Retail] = @Retail, [Category] = @Category WHERE [ISBN] = @ISBN">
            <DeleteParameters>
                <asp:Parameter Name="ISBN" Type="String" />
            </DeleteParameters>
            <InsertParameters>
                <asp:Parameter Name="ISBN" Type="String" />
                <asp:Parameter Name="Title" Type="String" />
                <asp:Parameter Name="PubDate" Type="DateTime" />
                <asp:Parameter Name="PubID" Type="Double" />
                <asp:Parameter Name="Cost" Type="Double" />
                <asp:Parameter Name="Retail" Type="Double" />
                <asp:Parameter Name="Category" Type="String" />
            </InsertParameters>
            <SelectParameters>
                <asp:ControlParameter ControlID="ddlPublishers" DefaultValue="1" Name="PubID" PropertyName="SelectedValue" Type="Double" />
            </SelectParameters>
            <UpdateParameters>
                <asp:Parameter Name="Title" Type="String" />
                <asp:Parameter Name="PubDate" Type="DateTime" />
                <asp:Parameter Name="PubID" Type="Double" />
                <asp:Parameter Name="Cost" Type="Double" />
                <asp:Parameter Name="Retail" Type="Double" />
                <asp:Parameter Name="Category" Type="String" />
                <asp:Parameter Name="ISBN" Type="String" />
            </UpdateParameters>
        </asp:SqlDataSource>
       
        <asp:GridView ID="GVBooks" runat="server" AutoGenerateColumns="False" CellPadding="4" DataKeyNames="ISBN" DataSourceID="DS_grdBooks" EmptyDataText="There are no data records to display." ForeColor="#333333" GridLines="None" AllowSorting="True">
            <AlternatingRowStyle BackColor="White" />
            <Columns>
                <asp:BoundField DataField="ISBN" HeaderText="ISBN" ReadOnly="True" SortExpression="ISBN" >
                <HeaderStyle Font-Bold="True" />
                <ItemStyle Font-Bold="True" />
                </asp:BoundField>
                <asp:BoundField DataField="Title" HeaderText="Title" SortExpression="Title" >
                <HeaderStyle HorizontalAlign="Center" />
                <ItemStyle HorizontalAlign="Center" />
                </asp:BoundField>
                <asp:BoundField DataField="PubDate" HeaderText="Publish Date" SortExpression="PubDate" DataFormatString="{0:d}" >
                <HeaderStyle HorizontalAlign="Right" />
                <ItemStyle HorizontalAlign="Right" />
                </asp:BoundField>
                <asp:BoundField DataField="PubID" HeaderText="PubID" SortExpression="PubID" Visible="False" />
                <asp:BoundField DataField="Cost" HeaderText="Wholesale" SortExpression="Cost" DataFormatString="{0:c}" >
                <HeaderStyle HorizontalAlign="Right" />
                <ItemStyle HorizontalAlign="Right" />
                </asp:BoundField>
                <asp:BoundField DataField="Retail" HeaderText="Retail" SortExpression="Retail" DataFormatString="{0:c}" >
                <HeaderStyle HorizontalAlign="Right" />
                <ItemStyle HorizontalAlign="Right" />
                </asp:BoundField>
                <asp:BoundField DataField="Category" HeaderText="Category" SortExpression="Category" >
                <HeaderStyle HorizontalAlign="Center" />
                <ItemStyle HorizontalAlign="Center" />
                </asp:BoundField>
            </Columns>
            <EditRowStyle BackColor="#2461BF" />
            <FooterStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <HeaderStyle BackColor="#507CD1" Font-Bold="True" ForeColor="White" />
            <PagerStyle BackColor="#2461BF" ForeColor="White" HorizontalAlign="Center" />
            <RowStyle BackColor="#EFF3FB" />
            <SelectedRowStyle BackColor="#D1DDF1" Font-Bold="True" ForeColor="#333333" />
            <SortedAscendingCellStyle BackColor="#F5F7FB" />
            <SortedAscendingHeaderStyle BackColor="#6D95E1" />
            <SortedDescendingCellStyle BackColor="#E9EBEF" />
            <SortedDescendingHeaderStyle BackColor="#4870BE" />
        </asp:GridView>
       
        <asp:SqlDataSource ID="ds_ddl_Publisher" runat="server" ConnectionString="<%$ ConnectionStrings:connStrBooksDB %>" SelectCommand="SELECT [PubID], [Name] FROM [Publisher]"></asp:SqlDataSource>
    
         <asp:DetailsView ID="DVBooks" runat="server" AllowPaging="True" CellPadding="4" DataSourceID="DV_Books" Height="50px" Width="587px" AutoGenerateRows="False" DataKeyNames="ISBN" BackColor="White" BorderColor="#CC9966" BorderStyle="None" BorderWidth="1px">
            <EditRowStyle BackColor="#FFCC66" Font-Bold="True" ForeColor="#663399" />
            <Fields>
                <asp:TemplateField HeaderText="ISBN" SortExpression="ISBN">
                    <EditItemTemplate>
    <%--Text='<%# Eval("ISBN")--%>                    
                    <asp:Label ID="Label1" runat="server"  BackColor="#CCCCCC" Text="Cannot Edit ISBN" ForeColor="Black"></asp:Label>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("ISBN") %>'></asp:TextBox>
                        <asp:RegularExpressionValidator ID="RegularExpressionValidator1" runat="server" ControlToValidate="TextBox1" Display="Dynamic" ErrorMessage="10 diget number" ValidationExpression="([0-9]{10})" CssClass="myerror"></asp:RegularExpressionValidator>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator11" runat="server" ControlToValidate="TextBox1" CssClass="myerror" Display="Dynamic" ErrorMessage="Required"></asp:RequiredFieldValidator>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        
                        <asp:Label ID="Label1" runat="server" Text='<%# Bind("ISBN") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Title" SortExpression="Title">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox4" runat="server" Text='<%# Bind("Title") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator1" runat="server" ControlToValidate="TextBox4" ErrorMessage="Required" CssClass="myerror" Display="Dynamic"></asp:RequiredFieldValidator>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:TextBox ID="TextBox5" runat="server" Text='<%# Bind("Title") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator2" runat="server" ControlToValidate="TextBox5" ErrorMessage="Required" CssClass="myerror" Display="Dynamic"></asp:RequiredFieldValidator>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label5" runat="server" Text='<%# Bind("Title") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="PubDate" SortExpression="PubDate">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox3" runat="server" Text='<%# Bind("PubDate", "{0:d}") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator9" runat="server" BorderStyle="None" ClientIDMode="Static" CssClass="myerror" Display="Dynamic" ErrorMessage="Required" ControlToValidate="TextBox3"></asp:RequiredFieldValidator>
                        <asp:CompareValidator ID="CompareValidator1" runat="server" ControlToValidate="TextBox3" CssClass="myerror" Display="Dynamic" ErrorMessage="mm/dd/yyyy format" Operator="DataTypeCheck" Type="Date"></asp:CompareValidator>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:TextBox ID="TextBox4" runat="server" Text='<%# Bind("PubDate", "{0:d}") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator10" runat="server" ControlToValidate="TextBox4" CssClass="myerror" Display="Dynamic" ErrorMessage="Required"></asp:RequiredFieldValidator>
                        <asp:CompareValidator ID="CompareValidator2" runat="server" ControlToValidate="TextBox4" CssClass="myerror" Display="Dynamic" ErrorMessage="mm/dd/yyyy format" Operator="DataTypeCheck" Type="Date"></asp:CompareValidator>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label4" runat="server" Text='<%# Bind("PubDate", "{0:d}") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Publisher" SortExpression="PubID">
                    <EditItemTemplate>
                        <asp:DropDownList ID="DropDownList1" runat="server" DataSourceID="ddlPubEditInsert" DataTextField="Name" DataValueField="PubID" SelectedValue='<%# Bind("PubID") %>'>
                        </asp:DropDownList>
                        <asp:SqlDataSource ID="ddlPubEditInsert" runat="server" ConnectionString="<%$ ConnectionStrings:connStrBooksDB %>" SelectCommand="SELECT * FROM [Publisher] ORDER BY [Name]"></asp:SqlDataSource>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator7" runat="server" ControlToValidate="DropDownList1" CssClass="myerror" ErrorMessage="Required" Display="Dynamic"></asp:RequiredFieldValidator>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:DropDownList ID="DropDownList2" runat="server" DataSourceID="ddlPubInsertOnly" DataTextField="Name" DataValueField="PubID" SelectedValue='<%# Bind("PubID") %>'>
                        </asp:DropDownList>
                        <asp:SqlDataSource ID="ddlPubInsertOnly" runat="server" ConnectionString="<%$ ConnectionStrings:connStrBooksDB %>" SelectCommand="SELECT * FROM [Publisher] ORDER BY [Name]"></asp:SqlDataSource>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator8" runat="server" ControlToValidate="DropDownList2" CssClass="myerror" ErrorMessage="Required" Display="Dynamic"></asp:RequiredFieldValidator>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label6" runat="server" Text='<%# Bind("PubID") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Cost" SortExpression="Cost">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("Cost") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator3" runat="server" ControlToValidate="TextBox1" ErrorMessage="Required" CssClass="myerror" Display="Dynamic"></asp:RequiredFieldValidator>
                        <asp:CompareValidator ID="CompareValidator3" runat="server" ControlToValidate="TextBox1" CssClass="myerror" Display="Dynamic" EnableTheming="True" ErrorMessage="Value must be greater than 4.99" Operator="GreaterThan" Type="Double" ValueToCompare="4.99"></asp:CompareValidator>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("Cost", "{0:c}") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator4" runat="server" ControlToValidate="TextBox2" ErrorMessage="Required" CssClass="myerror" Display="Dynamic"></asp:RequiredFieldValidator>
                        <asp:CompareValidator ID="CompareValidator4" runat="server" ControlToValidate="TextBox2" CssClass="myerror" Display="Dynamic" ErrorMessage="must be at least 4.99" Operator="GreaterThan" Type="Double" ValueToCompare="4.99"></asp:CompareValidator>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label2" runat="server" Text='<%# Bind("Cost", "{0:c}") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:TemplateField HeaderText="Retail" SortExpression="Retail">
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox2" runat="server" Text='<%# Bind("Retail") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator5" runat="server" ControlToValidate="TextBox2" ErrorMessage="Required" CssClass="myerror" Display="Dynamic"></asp:RequiredFieldValidator>
                        <asp:CompareValidator ID="CompareValidator5" runat="server" ControlToCompare="TextBox1" ControlToValidate="TextBox2" CssClass="myerror" Display="Dynamic" ErrorMessage="must be greater than the cost" Operator="GreaterThan" Type="Double"></asp:CompareValidator>
                    </EditItemTemplate>
                    <InsertItemTemplate>
                        <asp:TextBox ID="TextBox3" runat="server" Text='<%# Bind("Retail", "{0:c}") %>'></asp:TextBox>
                        <asp:RequiredFieldValidator ID="RequiredFieldValidator6" runat="server" ControlToValidate="TextBox3" ErrorMessage="Required" CssClass="myerror" Display="Dynamic"></asp:RequiredFieldValidator>
                        <asp:CompareValidator ID="CompareValidator6" runat="server" ControlToCompare="TextBox2" ControlToValidate="TextBox3" CssClass="myerror" Display="Dynamic" ErrorMessage="must be greater than cost" Operator="GreaterThan" Type="Double"></asp:CompareValidator>
                    </InsertItemTemplate>
                    <ItemTemplate>
                        <asp:Label ID="Label3" runat="server" Text='<%# Bind("Retail", "{0:c}") %>'></asp:Label>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:BoundField DataField="Category" HeaderText="Category" SortExpression="Category" />
                <asp:CommandField ShowDeleteButton="True" ShowEditButton="True" ShowInsertButton="True" />
            </Fields>
            <FooterStyle BackColor="#FFFFCC" ForeColor="#330099" />
            <HeaderStyle BackColor="#990000" Font-Bold="True" ForeColor="#FFFFCC" />
            <PagerStyle BackColor="#FFFFCC" ForeColor="#330099" HorizontalAlign="Center" />
             <RowStyle BackColor="White" ForeColor="#330099" />
        </asp:DetailsView>
        
        
        
        
        <asp:SqlDataSource ID="DV_Books" runat="server" ConnectionString="<%$ ConnectionStrings:connStrBooksDB %>" DeleteCommand="DELETE FROM [Books] WHERE [ISBN] = @ISBN" InsertCommand="INSERT INTO [Books] ([ISBN], [Title], [PubDate], [PubID], [Cost], [Retail], [Category]) VALUES (@ISBN, @Title, @PubDate, @PubID, @Cost, @Retail, @Category)" SelectCommand="SELECT * FROM [Books]" UpdateCommand="UPDATE [Books] SET [Title] = @Title, [PubDate] = @PubDate, [PubID] = @PubID, [Cost] = @Cost, [Retail] = @Retail, [Category] = @Category WHERE [ISBN] = @ISBN">
            <DeleteParameters>
                <asp:Parameter Name="ISBN" Type="String" />
            </DeleteParameters>
            <InsertParameters>
                <asp:Parameter Name="ISBN" Type="String" />
                <asp:Parameter Name="Title" Type="String" />
                <asp:Parameter Name="PubDate" Type="DateTime" />
                <asp:Parameter Name="PubID" Type="Double" />
                <asp:Parameter Name="Cost" Type="Double" />
                <asp:Parameter Name="Retail" Type="Double" />
                <asp:Parameter Name="Category" Type="String" />
            </InsertParameters>
            <UpdateParameters>
                <asp:Parameter Name="Title" Type="String" />
                <asp:Parameter Name="PubDate" Type="DateTime" />
                <asp:Parameter Name="PubID" Type="Double" />
                <asp:Parameter Name="Cost" Type="Double" />
                <asp:Parameter Name="Retail" Type="Double" />
                <asp:Parameter Name="Category" Type="String" />
                <asp:Parameter Name="ISBN" Type="String" />
            </UpdateParameters>
        </asp:SqlDataSource>
        
        
        
        
        <footer>
          <nav>
        <ul>
            <li><a href="Default.aspx">Home Page</a></li>
        </ul>
    </nav>
    </footer>
    </form>
    </body>
</html>
